## cri-o 1.25.2~0

=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.25.1
+UPSTREAM_TAG=v1.25.2
 
 %:
 	dh_clean
