## cri-o 1.25.3~0

=== debian/changelog ===
cri-o (1.25.3~0) stable; urgency=medium

  * bump to v1.25.3

 -- Peter Hunt <haircommander@fedoraproject.org>  Tue, 04 Apr 2023 10:42:21 -0400
