## cri-o 1.25.4~0

=== debian/changelog ===
cri-o (1.25.4~0) stable; urgency=medium

  * bump to v1.25.4

 -- Peter Hunt <haircommander@fedoraproject.org>  Thu, 10 Aug 2023 13:40:16 +0530
