## cri-o 1.26.4~1

=== Makefile ===
--- 
+++ 
@@ -92,6 +92,10 @@
 GOPKGBASEDIR := $(shell dirname "$(GOPKGDIR)")
 GO_FILES := $(shell find . -type f -name '*.go' -not -name '*_test.go')
 
+# Some of the packages use the golang testing infra in end-to-end tests.
+# These can't be run as unit tests so ginkgo should skip them.
+GINKGO_SKIP_PACKAGES = test/nri
+
 # Update VPATH so make finds .gopathok
 VPATH := $(VPATH):$(GOPATH)
 
@@ -173,6 +177,9 @@
 		-x \
 		${SHELLFILES} ${BATS_FILES}
 
+check-nri-bats-tests: test/nri/nri.test
+	./hack/check-nri-bats-tests.sh
+
 bin/pinns:
 	$(MAKE) -C pinns
 
@@ -184,6 +191,9 @@
 
 test/checkcriu/checkcriu: $(GO_FILES) .gopathok
 	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/test/checkcriu
+
+test/nri/nri.test: $(wildcard test/nri/*.go) .gopathok
+	$(GO) test --tags "test $(BUILDTAGS)" -c $(PROJECT)/test/nri -o $@ 
 
 bin/crio: $(GO_FILES) .gopathok
 	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/cmd/crio
@@ -229,6 +239,7 @@
 	rm -f test/copyimg/copyimg
 	rm -f test/checkseccomp/checkseccomp
 	rm -f test/checkcriu/checkcriu
+	rm -f test/nri/nri.test
 	rm -rf ${BUILD_BIN_PATH}
 
 # the approach here, rather than this target depending on the build targets
@@ -281,7 +292,7 @@
 bom: ${BOM}
 
 ${GOLANGCI_LINT}:
-	export VERSION=v1.49.0 \
+	export VERSION=v1.50.1 \
 		URL=https://raw.githubusercontent.com/golangci/golangci-lint \
 		BINDIR=${BUILD_BIN_PATH} && \
 	curl -sSfL $$URL/$$VERSION/install.sh | sh -s $$VERSION
@@ -308,6 +319,7 @@
 	${BUILD_BIN_PATH}/ginkgo run \
 		${TESTFLAGS} \
 		-r \
+		--skip-package $(GINKGO_SKIP_PACKAGES) \
 		--trace \
 		--cover \
 		--covermode atomic \
@@ -386,14 +398,3 @@
 	./test/test_runner.sh ${TESTFLAGS}
 
 binaries: bin/crio bin/crio-status bin/pinns
-test-binaries: test/copyimg/copyimg test/checkseccomp/checkseccomp test/checkcriu/checkcriu
-
-MANPAGES_MD := $(wildcard docs/*.md)
-MANPAGES    := $(MANPAGES_MD:%.md=%)
-
-docs/%.5: docs/%.5.md .gopathok ${GO_MD2MAN}
-	(${GO_MD2MAN} -in $< -out $@.tmp && touch $@.tmp && mv $@.tmp $@) || \
-		(${GO_MD2MAN} -in $< -out $@.tmp && touch $@.tmp && mv $@.tmp $@)
-
-docs/%.8: docs/%.8.md .gopathok ${GO_MD2MAN}
-	(${GO_MD2MAN} -in $< -out $@.tmp && touch $@.tmp && mv $@.tmp $@) || \
