=== debian/changelog ===
cri-o (1.26.4~1) stable; urgency=medium

  * bump to v1.26.4

 -- Peter Hunt <haircommander@fedoraproject.org>  Tue, 22 Aug 2023 12:23:41 +0530
