=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.25.4
+UPSTREAM_TAG=v1.26.4
 
 %:
 	dh_clean
@@ -66,8 +66,8 @@
 	   install.systemd
 	# install binaries
 	install -dp $(DESTDIR)/etc/cni/net.d
-	install -p -m 644 contrib/cni/10-crio-bridge.conf $(DESTDIR)/etc/cni/net.d/100-crio-bridge.conf
-	install -p -m 644 contrib/cni/99-loopback.conf $(DESTDIR)/etc/cni/net.d/200-loopback.conf
+	install -p -m 644 contrib/cni/10-crio-bridge.conflist $(DESTDIR)/etc/cni/net.d/100-crio-bridge.conflist
+	install -p -m 644 contrib/cni/99-loopback.conflist $(DESTDIR)/etc/cni/net.d/200-loopback.conflist
 	install -dp $(SYSCONFDIR)
 	install -p -m 644 contrib/sysconfig/crio $(SYSCONFDIR)
 	# install override file
