## cri-o 1.27.4~0

=== debian/changelog ===
cri-o (1.27.4~0) stable; urgency=medium

  * bump to v1.27.4

 -- Peter Hunt <haircommander@fedoraproject.org>  Wed, 06 Mar 2024 11:32:50 -0500

cri-o (1.27.2~0) stable; urgency=medium

  * bump to 1.27.2

 -- Peter Hunt <haircommander@fedoraproject.org>  Fri, 08 Dec 2023 13:56:30 -0500

cri-o (1.26.3~0) stable; urgency=medium

  * bump to v1.26.3

 -- Peter Hunt <haircommander@fedoraproject.org>  Mon, 10 Apr 2023 15:19:24 -0400

cri-o (1.26.2~0) stable; urgency=medium

  * bump to v1.26.2

 -- Peter Hunt <haircommander@fedoraproject.org>  Thu, 30 Mar 2023 13:34:06 -0400

cri-o (1.26.1~0) stable; urgency=medium

  * bump to v1.26.1

 -- Peter Hunt <haircommander@fedoraproject.org>  Tue, 10 Jan 2023 16:29:18 -0500

cri-o (1.26.0~0) stable; urgency=medium

  * bump to v1.26.0

 -- Peter Hunt <haircommander@fedoraproject.org>  Fri, 23 Dec 2022 00:33:09 -0500
